from descarteslabs.compute import Function

print("creating function")
async_func = Function(
    "compute_examples.complete.simplify",
    name="my-compute-hello",
    image="python3.10",
    include_modules=["compute_examples"],
    include_data=["compute_examples/data/*.json"],
    requirements=["geopandas"],
    cpus=1,
    memory=2048,
    maximum_concurrency=1,
    timeout=600,
    retry_count=1,
)
async_func.save()

# submit a job to the function
print("submitting a job")
job = async_func(5)

print("waiting for the job to complete")
job.wait_for_completion()

print("job status:")
print(job.status())
print("job result:")
print(job.result())
print("job log:")
print(job.log())
